/*
Copyright (c) 2001-2005 MakeHuman team www.makehuman.org
Author: Paolo Colombo

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef FILE_UTIL_H
#define FILE_UTIL_H

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#ifndef _WIN32
#include <stdbool.h>
#include <pwd.h>
#include <sys/types.h>
#ifndef __APPLE__
#include <linux/limits.h>
#endif
#include <dirent.h>
#define MAX_PATH _POSIX_PATH_MAX
#include <unistd.h>
#endif

#ifdef HAVE_CONFIG_H
#define DATA_DIR PACKAGE_DATA_DIR"/targets/"
#define IMAGE_DIR PACKAGE_DATA_DIR"/UI/tgimg/"
#else
#define DATA_DIR "targets/"
#define IMAGE_DIR "UI/tgimg/"
#endif

#define APP_HOME ".makehuman"

void ScanDir(char *dirname);
void _scanTargetDir();
char *getHomeDir ();
char *getAppHomeDir ();
int initAppHome ();
void Animation();
int LoadBodysetting(char *name);
void SaveBodysetting(char *name);
void writeRib(FILE *ribfileout, char *imgfile, int xres, int yres);
void writeLamps(FILE *ribfileout);
void subdivmesh(char *fileObj);
void writeObjs(FILE *ribfileout, char *ribObjDir);
void MakeRib(int mode, char *fName, char *imgName, int xres, int yres, char *engine);
void commandExec(char *command, char *par1, char *param);
int saveOBJ (/*char *filename*/);


#endif // FILE_UTIL_H
