/*
Copyright (c) 2001-2005 MakeHuman team www.makehuman.org
Author: Paolo Colombo

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#include <GL/gl.h>
#endif

#include "make_human.h"
#include "target_list.h"

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>



//#define FACECOLOR .37,0.56,0.71, 0.6
#define FACECOLOR .4,0.4,0.4,1


GLint vertex = 0;
GLint faces = 0;
GLdouble **original_vertex_coor; //Vettore bidimensionale [indice][x,y,z] per la lista dei vertici originali
GLdouble **vertex_coor; //Vettore bidimensionale [indice][x,y,z] per la lista dei vertici da disegnare a video
GLdouble **norm_coor;  //Vettore bidimensionale [indice][x,y,z] per la lista delle normali dei vertici
GLint **face_index; //Vettore bidimensionale [indice][index x,index y,index z] per la lista delle facce
//GLdouble norm_face[10857][3]; //Vettore bidimensionale [indice faccia][] per la lista delle facce
GLdouble **norm_face; //Vettore bidimensionale [indice faccia][] per la lista delle facce
GLint *Tri_quad; //Vettore [3 o 4] indica se la faccia  di 3 o 4 vertici
GLdouble **target_coor; //Vettore bidimensionale [indice][x,y,z] per la lista dei vertici del target contine il target corrente
GLdouble **anim_coor; //Vettore bidimensionale [indice][x,y,z] per la lista dei vertici del target contine il target delle animaoni
GLint numofVertsAnim = 0; // Variabile di utilit, contiene il numero dei vertici del target attivo per  le anim
GLint numofVerts = 0; // Variabile di utilit, contiene il numero dei vertici del target attivo

//unsigned int Count_Target = 0; //Contatore dei target usati inizializzato a 0, viene incrementato da load_target;
//char *TargetUsed; //Vettore [nome target, valore applicato] per i target usati;




/*
float pippo = 0; //usato solo per test rimuovere per release
*/

void load_model(int argc, char **argv)
{
  FILE *file;
  //FILE *normals;
  int i, j;
  char buf[80];
  char cpy[80];
  const char *util;
  //const char *util2;
  char token[] = ",";

  if(argc > 1)
  {
  }
  else{
    //file = fopen(argv[1], "r");
#ifdef HAVE_CONFIG_H
    file = fopen(PACKAGE_DATA_DIR"/base.mesh", "r");
#else
    file = fopen("base.mesh", "r");
#endif
    //	normals = fopen("norm.mesh", "r");
    //printf("Loading... %s\n", argv[1]);
    //printf("Test %s\n\n", strtok(argv[1], "."));
    if(!file)
    {
      printf("Open File Failed: File \"%s\" does not exist.\n", argv[1]);
      exit(1);
    }
    while( fgets( buf, 80, file ))
    {
      vertex++;
    }
    printf("Vertex number: %d\n\n", vertex);
    original_vertex_coor = (GLdouble **)malloc(vertex * sizeof(GLdouble *));
    vertex_coor = (GLdouble **)malloc(vertex * sizeof(GLdouble *));
    norm_coor = (GLdouble **)malloc(vertex * sizeof(GLdouble *));
    rewind(file);
    for(i = 0; i < vertex; i++)
    {
      original_vertex_coor[i] = (GLdouble *)malloc(3 * sizeof(GLdouble));
      vertex_coor[i] = (GLdouble *)malloc(3 * sizeof(GLdouble));
      fscanf(file, "%s", buf);
      util = strtok (buf, token);
      vertex_coor[i][0] = atof(util);
      original_vertex_coor[i][0] = atof(util);
      util = strtok (NULL, token);
      vertex_coor[i][1] = atof(util);
      original_vertex_coor[i][1] = atof(util);
      util = strtok (NULL, token);
      vertex_coor[i][2] = atof(util);
      original_vertex_coor[i][2] = atof(util);

      //		norm_coor[i] = (GLdouble *)malloc(3 * sizeof(GLdouble));
      //		fscanf(normals, "%s", buf);
      //		util2 = strtok (buf, token);
      //		norm_coor[i][0] = atof(util2);
      //		util = strtok (NULL, token);
      //		norm_coor[i][1] = atof(util2);
      //		util = strtok (NULL, token);
      //		norm_coor[i][2] = atof(util2);

    }
    fclose(file);

    //memcpy(original_vertex_coor, vertex_coor, sizeof(vertex_coor));

    //memcpy (original_vertex_coor, vertex_coor, sizeof vertex_coor * sizeof (GLdouble));
    //	fclose(normals);
  }
#ifdef HAVE_CONFIG_H
  file = fopen(PACKAGE_DATA_DIR"/faces.mesh", "r");
#else
  file = fopen("faces.mesh", "r");
#endif
  if(!file)
  {
    printf("Open File Failed: File \"%s\" does not exist.\n", argv[1]);
    exit(1);
  }
  while( fgets( buf, 80, file))
  {
    faces++;
  }
  printf("Face number: %d\n\n", faces);
  Tri_quad = (GLint *)malloc(faces * sizeof(GLint));
  face_index = (GLint **)malloc(faces * sizeof(GLint *));
  norm_face = (GLdouble **)malloc(faces * sizeof(GLdouble *));
  rewind(file);
  for(i = 0; i < faces; i++)
  {
    norm_face[i]= (GLdouble *)malloc(3 * sizeof(GLdouble));
    fgets(buf, 80, file);
    strcpy(cpy, buf);
    j = 0;
    util = strtok (buf, token);
    while (util != NULL)
    {
      //printf("%d\n", atoi(util));
      util = strtok (NULL, token);
      j++;
    }
    Tri_quad[i] = j;
    face_index[i] = (GLint *)malloc(j * sizeof(GLint));
    j=0;
    util = strtok (cpy, token);
    while (util != NULL)
    {
      //printf("%d\n", atoi(util));
      //face_index[i] = (GLint *)malloc(j * sizeof(GLint));
      face_index[i][j] = atoi(util);
      //printf("%d\n", face_index[i][j]);
      //printf("%d\n", atoi(util));
      util = strtok (NULL, token);
      j++;
    }
  }
  fclose(file);

  calculate_vertex_normal ();
}


static GLuint display_list = 0;

void update_mesh()
{
	display_list = 0;
}

void Draw_model()
{
  int i;
	int compile_list = 0;

/*
	if(display_list)
	{
		glCallList(display_list);
		return;
	}
	else
	{
		compile_list = 1;
		display_list = glGenLists(1);
		glNewList(display_list, GL_COMPILE_AND_EXECUTE);
	}
*/

  //glDisable(GL_LIGHTING);
  //glEnable(GL_BLEND);
  glDisable (GL_BLEND);
  glEnable(GL_POLYGON_OFFSET_FILL);
  glPolygonOffset(1.0, 1.0);

  for(i=0; i<faces; i++)
  {
    if (Tri_quad[i]==4){
      glNormal3dv(norm_face[i]);
      glBegin(GL_QUADS);
      glColor4f(FACECOLOR);
      //glNormal3dv(norm_coor[face_index[i][0]]);
      glVertex3dv(vertex_coor[face_index[i][0]]);
      glColor4f(FACECOLOR);
      //glNormal3dv(norm_coor[face_index[i][1]]);
      glVertex3dv(vertex_coor[face_index[i][1]]);
      glColor4f(FACECOLOR);
      //glNormal3dv(norm_coor[face_index[i][2]]);
      glVertex3dv(vertex_coor[face_index[i][2]]);
      glColor4f(FACECOLOR);
      //glNormal3dv(norm_coor[face_index[i][3]]);
      glVertex3dv(vertex_coor[face_index[i][3]]);
      glEnd();
    }
    else{
      glNormal3dv(norm_face[i]);
      glBegin(GL_TRIANGLES);
      glColor4f(FACECOLOR);
      //glNormal3dv(norm_coor[face_index[i][0]]);
      glVertex3dv(vertex_coor[face_index[i][0]]);
      //glNormal3dv(norm_coor[face_index[i][1]]);
      glColor4f(FACECOLOR);
      glVertex3dv(vertex_coor[face_index[i][1]]);
      //glNormal3dv(norm_coor[face_index[i][2]]);
      glColor4f(FACECOLOR);
      glVertex3dv(vertex_coor[face_index[i][2]]);
      glEnd();

    }
  }
  glDisable(GL_POLYGON_OFFSET_FILL);


  glDisable(GL_LIGHTING);
  glEnable(GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  //glColor4f(.37, .56, .71,1);
  glColor4f(0.2, 0.2, 0.2, .6);
  for(i=0; i<faces; i++)
  {
    if (Tri_quad[i]==4){
      //glNormal3dv(norm_face[i]);
      glBegin(GL_LINE_LOOP);
      //glColor3f(.4,.0,.4);
      //glNormal3dv(norm_coor[face_index[i][0]]);
      glVertex3dv(vertex_coor[face_index[i][0]]);
      //glColor3f(.4,.0,.4);
      //glNormal3dv(norm_coor[face_index[i][1]]);
      glVertex3dv(vertex_coor[face_index[i][1]]);
      //glColor3f(.4,.0,.4);
      //glNormal3dv(norm_coor[face_index[i][2]]);
      glVertex3dv(vertex_coor[face_index[i][2]]);
      //glColor3f(.4,.0,.4);
      //glNormal3dv(norm_coor[face_index[i][3]]);
      glVertex3dv(vertex_coor[face_index[i][3]]);
      glEnd();
    }
    else{
      //glNormal3dv(norm_face[i]);
      glBegin(GL_LINE_LOOP);
      //glColor3f(.4,.0,.4);
      //glNormal3dv(norm_coor[face_index[i][0]]);
      glVertex3dv(vertex_coor[face_index[i][0]]);
      //glNormal3dv(norm_coor[face_index[i][1]]);
      //glColor3f(.4,.0,.4);
      glVertex3dv(vertex_coor[face_index[i][1]]);
      //glNormal3dv(norm_coor[face_index[i][2]]);
      //glColor3f(.4,.0,.4);
      glVertex3dv(vertex_coor[face_index[i][2]]);
      glEnd();

    }
  }

  glDisable(GL_BLEND);
  glEnable(GL_LIGHTING);
  /*
  glColor3f(0.0, 0.0, 0.0);
  glPointSize(3.0);
  glEnable(GL_CULL_FACE);
  //glCullFace(GL_BACK);


  glDisable(GL_LIGHTING);
  //glDisable(GL_DEPTH_TEST);
  glBegin(GL_POINTS);
  	for(i = 0; i < vertex; i++)
  	{
  		glVertex3dv(vertex_coor[i]);
  	}
  glEnd();
  //glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);
  */

	if(compile_list)
		glEndList();
}



int Load_Target(char *target_to_open)
{
  FILE *target;
  int i, numvert = 0;
  char buf[80];
  const char *util;
  char token[] = ",";

  if (numofVerts != 0){
    for(i=0; i<numofVerts;++i)
    {
      free(target_coor[i]);
    }
    free(target_coor);
    numofVerts = 0;
  }
  target = fopen(target_to_open, "r");
  if(!target)
  {
    printf("Open File Failed: %s\n", target_to_open);
    return 1;
  }
  while( fgets( buf, 80, target ))
  {
    numvert++;
  }
  //printf("Numero Vertici nel target: %d\n\n", numvert);
  target_coor = (GLdouble **)malloc(numvert * sizeof(GLdouble *));
  rewind(target);
  for(i = 0; i < numvert; i++)
  {
    target_coor[i] = (GLdouble *)malloc(4 * sizeof(GLdouble));
    fscanf(target, "%s", buf);
    util = strtok (buf, token);
    target_coor[i][0] = atof(util);
    util = strtok (NULL, token);
    target_coor[i][1] = atof(util);
    util = strtok (NULL, token);
    target_coor[i][2] = atof(util);
    util = strtok (NULL, token);
    target_coor[i][3] = atof(util);
  }
  fclose(target);

  numofVerts = numvert;
  return 0;
}

void Load_Target_Anim(char *target_to_open)
{
  FILE *target;
  int i, numvert = 0;
  char buf[80];
  const char *util;
  char token[] = ",";

  if (numofVertsAnim != 0){
    for(i=0; i<numofVertsAnim;++i)
    {
      free(anim_coor[i]);
    }
    free(anim_coor);
  }
  target = fopen(target_to_open, "r");
  if(!target)
  {
    printf("Open File Failed: File does not exist %s.\n", target_to_open);
    exit(1);
  }
  while( fgets( buf, 80, target ))
  {
    numvert++;
  }
  //printf("Numero Vertici nel target: %d\n\n", numvert);
  anim_coor = (GLdouble **)malloc(numvert * sizeof(GLdouble *));
  rewind(target);
  for(i = 0; i < numvert; i++)
  {
    anim_coor[i] = (GLdouble *)malloc(4 * sizeof(GLdouble));
    fscanf(target, "%s", buf);
    util = strtok (buf, token);
    anim_coor[i][0] = atof(util);
    util = strtok (NULL, token);
    anim_coor[i][1] = atof(util);
    util = strtok (NULL, token);
    anim_coor[i][2] = atof(util);
    util = strtok (NULL, token);
    anim_coor[i][3] = atof(util);
  }
  fclose(target);

  numofVertsAnim = numvert;
}
void Do_Morph(char *target, double value)
{
  int j;
  int index;
  double x,y,z, valueApp;

  valueApp = value;

  if(isInList(target, TargetUsed)){
    if(value == 0.0){
      value = getValue(target, TargetUsed)*-1;
      setValue(target, TargetUsed, valueApp);
    }
    else {
      value = (getValue(target, TargetUsed)*-1) +value;
      setValue(target, TargetUsed, valueApp);
    }
  }else {
    TargetUsed = addTarget(TargetUsed, target, value);
  }

  for(j=0; j<numofVerts;j++)
  {
    index = target_coor[j][0];
    x = target_coor[j][1];
    y = target_coor[j][2];
    z = target_coor[j][3];

    vertex_coor[index][0] += (x - original_vertex_coor[index][0]) * value;
    vertex_coor[index][1] += (y - original_vertex_coor[index][1]) * value;
    vertex_coor[index][2] += (z - original_vertex_coor[index][2]) * value;
  }

  //printf("numero vertivi: %d\n", numofVerts);
  //for(j=0; j<i;++j)
  //{
  //	free(target_coor[j]);
  //}
  //free(target_coor);
  //glutPostRedisplay();
  //glutSwapBuffers();
  //if(valueApp == 0.0) TargetUsed = removeTarget(TargetUsed, target);
  //printlist(TargetUsed);
  ///glutPostRedisplay();
  //display();
}

void Do_Morph_Anim(char *target, double value)
{
  int j;
  int index;
  double x,y,z, valueApp;
  static double prevVal = 0.0;

  valueApp = value;

  if(value == 0.0){
    value = prevVal*-1;
    prevVal = valueApp;
  }
  else {
    value = (prevVal*-1) +value;
    prevVal = valueApp;
  }


  /*
  valueApp = value;
  value
  //printf("Target has: %d vertex\nIl Target : %s\nIl Valore : %f\n", numofVerts, target, value);
  //printf("Valore passato : %.3f\n", value);
  if(isInList(target, TargetUsed)){
  	//printf("Gi applicato\n");
  	
  	//TargetUsed = addTarget(TargetUsed, target, value);
  	//setValue(target, TargetUsed, value);
  	
  }else {
  	//printf("Prima Volta\n");
  	TargetUsed = addTarget(TargetUsed, target, value);
  }

  //printf("i target sono\n");

  //addTarget(&TargetUsed, "targets/head/head_baby.target", value);
  //printf("%s, %f, %d\n", TargetUsed->TargetName, TargetUsed->Value, TargetUsed->NumOfTarget);

  */

  for(j=0; j<numofVertsAnim;j++)
  {
    index = anim_coor[j][0];
    x = anim_coor[j][1];
    y = anim_coor[j][2];
    z = anim_coor[j][3];

    vertex_coor[index][0] += (x - original_vertex_coor[index][0]) * value;
    vertex_coor[index][1] += (y - original_vertex_coor[index][1]) * value;
    vertex_coor[index][2] += (z - original_vertex_coor[index][2]) * value;
  }

  //printf("numero vertivi: %d\n", numofVerts);
  //for(j=0; j<i;++j)
  //{
  //	free(target_coor[j]);
  //}
  //free(target_coor);
  //glutPostRedisplay();
  //glutSwapBuffers();
  //if(valueApp == 0.0) TargetUsed = removeTarget(TargetUsed, target);
  //printlist(TargetUsed);
  ///glutPostRedisplay();
  //display();
}




void calculate_vertex_normal ()
{

  int i,j,k ;
  float p1[3], p2[3], p3[3];
  float norm[3] ;


  for(i=0; i<faces; i++)
  {
    for(j=0; j<3; j++){
      //printf("----> %f \n", vertex_coor[face_index[i][0]][j]);
      p1[j] = vertex_coor[face_index[i][0]][j];
    }
    for(j=0; j<3; j++){
      //printf("----> %f \n", vertex_coor[face_index[i][0]][j]);
      p2[j] = vertex_coor[face_index[i][1]][j];
    }
    for(j=0; j<3; j++){
      //printf("----> %f \n", vertex_coor[face_index[i][0]][j]);
      p3[j] = vertex_coor[face_index[i][2]][j];
    }

    calc_normal ( p1, p2, p3, norm ) ;
    for (k=0; k<3; k++) norm_face[i][k] = norm[k];

    /*	for (j=0; j<3; j++)
    		for (k=0; k<3; k++)
    			norm_coor[face_index[i][j]][k] = norm[k] ;*/

    //face->polygon[i]->vertex[j]->norm[k] = norm[k] ;


  }

  /*
    for (i=0; i<face->npolygons; i++ )
      {
        for (j=0; j<3; j++) 
  		p1[j] = face->polygon[i]->vertex[0]->xyz[j] ;
        for (j=0; j<3; j++) 
  		p2[j] = face->polygon[i]->vertex[1]->xyz[j] ;
        for (j=0; j<3; j++) 
  		p3[j] = face->polygon[i]->vertex[2]->xyz[j] ;

        calc_normal ( p1, p2, p3, norm ) ;

        for (j=0; j<3; j++) 
  		for (k=0; k<3; k++)
  			face->polygon[i]->vertex[j]->norm[k] = norm[k] ;
      }
  	
  	*/
}


/* ========================================================================= */
/* calc_normal.					     			     */
/* ========================================================================= */
/*** Calculates the normal vector from three vertices.*/

void calc_normal ( float *p1, float *p2, float *p3, float *norm )
{
  float coa, cob, coc ;
  float px1, py1, pz1 ;
  float px2, py2, pz2 ;
  float px3, py3, pz3 ;

  float absvec ;

  px1 = p1[0] ;
  py1 = p1[1] ;
  pz1 = p1[2] ;

  px2 = p2[0] ;
  py2 = p2[1] ;
  pz2 = p2[2] ;

  px3 = p3[0] ;
  py3 = p3[1] ;
  pz3 = p3[2] ;

  coa = -(py1 * (pz2-pz3) + py2*(pz3-pz1) + py3*(pz1-pz2)) ;
  cob = -(pz1 * (px2-px3) + pz2*(px3-px1) + pz3*(px1-px2)) ;
  coc = -(px1 * (py2-py3) + px2*(py3-py1) + px3*(py1-py2)) ;

  absvec = sqrt ((double) ((coa*coa) + (cob*cob) + (coc*coc))) ;

  norm[0] = coa/absvec ;
  norm[1] = cob/absvec ;
  norm[2] = coc/absvec ;

}


/* ========================================================================= */
/* averaged_vertex_normals                                                   */
/* ========================================================================= */
/*
** Caculates the averaged polygon normal.
*/
/*
void averaged_vertex_normals ( HEAD *face, int p, float *n1, float *n2, float *n3 ) 
{
  int i,j,np, pt ;
  float norm[3] ;


  for (i=0; i<3; i++)
    norm[i] = 0.0 ;

  np = face->polygon[p]->vertex[0]->np ;

  for ( i=0; i<np; i++) {
    pt = face->polygon[p]->vertex[0]->plist[i] ;

    for ( j=0; j<3; j++)  {
      norm[j] += face->polygon[pt]->vertex[0]->norm[j] ;
    }
  }

  for (i=0; i<3; i++)
    norm[i] = norm[i] / (float)np ;
    
  for (i=0; i<3; i++)
    n1[i] = norm[i] ;

  for (i=0; i<3; i++)
    norm[i] = 0.0 ;

  np = face->polygon[p]->vertex[1]->np ;

  for ( i=0; i<np; i++) {
    pt = face->polygon[p]->vertex[1]->plist[i] ;

    for ( j=0; j<3; j++) {
      norm[j] += face->polygon[pt]->vertex[1]->norm[j] ;
    }
  }

  for (i=0; i<3; i++)
    norm[i] = norm[i] / (float) np ;

  for (i=0; i<3; i++)
    n2[i] = norm[i] ;

  for (i=0; i<3; i++)
    norm[i] = 0.0 ;

  np = face->polygon[p]->vertex[2]->np ;

  for ( i=0; i<np; i++) {
    pt = face->polygon[p]->vertex[2]->plist[i] ;

    for ( j=0; j<3; j++) {
      norm[j] += face->polygon[pt]->vertex[2]->norm[j] ;
    }
  }

  for (i=0; i<3; i++)
    norm[i] = norm[i]/ (float) np ;
    
  for (i=0; i<3; i++)
    n3[i] = norm[i] ;
   
}

  */





