/*
Copyright (c) 2001-2005 MakeHuman team www.makehuman.org
Author: Paolo Colombo

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "target_list.h"

#include "glut_interface.h"
#include "make_human.h"
#include "io.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

TargetUsedStruct *addTarget(TargetUsedStruct *TargetUsed, char *TargetName, double Value) {

  TargetUsedStruct *tmp, *cur;

  tmp = (TargetUsedStruct *)malloc(sizeof(TargetUsedStruct));
  strcpy(tmp->TargetName, TargetName);
  tmp->Value = Value;
  tmp->next = NULL;

  cur = TargetUsed;
  if (cur == NULL) {
    TargetUsed = tmp;
  } else {
    while (cur->next != NULL)
      cur = cur->next;
    cur->next = tmp;
  }

  return TargetUsed;
}

TargetUsedStruct *removeTarget(TargetUsedStruct *TargetUsed, char *TargetName) {

  TargetUsedStruct *tmp = NULL, *cur;

  cur = TargetUsed;
  while (cur != NULL) {
    if (strcmp(cur->TargetName, TargetName) == 0) { /* A match in name */
      if (cur->next == NULL && tmp == NULL) { /* Only element case */
        free(cur);
        TargetUsed = NULL;
        break;
      } else {
        if (tmp == NULL) { /* First element case */
          TargetUsed = cur->next;
          free(cur);
          cur = TargetUsed;
        } else {
          tmp->next = cur->next;
          free(cur);
          cur = tmp->next;
        }
        continue;
      }
    }
    tmp = cur;
    cur = tmp->next;
  }
  return TargetUsed;
}


void setToZero(TargetUsedStruct *TargetUsed) {
  char tmp[MAX_PATH];

  TargetUsedStruct *point;
  point = TargetUsed;
  while (point != NULL)
  {
    if(point->Value != 0){
#ifdef HAVE_CONFIG_H
      sprintf (tmp, "%s/%s",PACKAGE_DATA_DIR, point->TargetName);
      Load_Target(tmp);      
#else
      Load_Target(point->TargetName);
#endif

      Do_Morph(point->TargetName, 0.0);
      display();
    }
    point = point->next;
  }

	// Ackownledge target update
	//update_mesh();
}

void printlist(TargetUsedStruct *TargetUsed) {
  TargetUsedStruct *point;
  point = TargetUsed;
  while (point != NULL)
  {
    printf("Target: %s  -  Value: %f\n", point->TargetName, point->Value);
    point = point->next;
  }
}



float getValue(char *TargetName, TargetUsedStruct *TargetUsed){

  TargetUsedStruct *point;
  point = TargetUsed;
  while (point != NULL)
  {
    if(strcmp(point->TargetName, TargetName) == 0) return point->Value;
    point = point->next;
  }
  return 0;
}

void setValue(char *TargetName, TargetUsedStruct *TargetUsed, double Value){

  TargetUsedStruct *point;
  point = TargetUsed;
  while (point != NULL)
  {
    if(strcmp(point->TargetName, TargetName) == 0){
      point->Value = Value;
    }
    point = point->next;
  }

}

int isInList(char *TargetName, TargetUsedStruct *TargetUsed){

  TargetUsedStruct *point;
  point = TargetUsed;
  while (point != NULL)
  {
    if(strcmp(point->TargetName, TargetName) == 0) return 1;
    point = point->next;
  }
  return 0;
}

