/*
Copyright (c) 2001-2005 MakeHuman team www.makehuman.org
Author: Paolo Colombo

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef TARGET_LIST_H
#define TARGET_LIST_H

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

typedef struct _Target_Used
{
	char TargetName[80];
	double Value;
	struct _Target_Used *next;
} TargetUsedStruct;

typedef struct _TargetList {
  int id;
  int numOfTargets;
  char *dirName;
  char targetNames[120][80];
}_targetList;


/* Global variables */
int counterDir;
int counterTargets;
TargetUsedStruct *TargetUsed;
_targetList targetList[120];

/* Function prototypes */
TargetUsedStruct *addTarget(TargetUsedStruct *TargetUsed, char *TargetName, double Value);
TargetUsedStruct *removeTarget(TargetUsedStruct *TargetUsed, char *TargetName);
void setToZero(TargetUsedStruct *TargetUsed);
void printlist(TargetUsedStruct *TargetUsed);
int isInList(char *TargetName, TargetUsedStruct *TargetUsed);
float getValue(char *TargetName, TargetUsedStruct *TargetUsed);
void setValue(char *TargetName, TargetUsedStruct *TargetUsed, double Value);


#endif // TARGET_LIST_H

