/*
Copyright (c) 2001-2005 MakeHuman team www.makehuman.org
Author: Paolo Colombo

this module use glpng libriray from http://www.wyatt100.freeserve.co.uk/download.htm


This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifdef __APPLE__
#include <GLUT/glut.h>
#include <OpenGL/glpng.h>
#else
#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glpng.h>
#endif

#include "ui.h"

#include "glut_interface.h"
#include "io.h"
#include "make_human.h"
#include "target_list.h"

#include <math.h>
#include <stdarg.h>
#include <string.h>





/* typedefs */
typedef struct _cell {
  int id;
  int x, y;
  int w, h;
  char *image;
  float imgOffsetY;
  float imgOffsetX;
  float alpha;				//Valore di Alpha dell'immagine (Serve per l'higlight del bottone al passaggio del mouse
  GLuint  texture;			//Testure Opengl in cui caricare l'immagine
  float min, max;
  float value;
  float step;
  char* info;
  float infox, infoy;
  char* help;
  char* format;
  char* target;
  int type;

} cell;




typedef struct {		//Struttura del bottone
  int id;
  int w, h;					// largezza e altezza del bottone
  int x, y;					//posizione del bottone
  char *image;				//Nome dell'immagine del bottone
  char *text;					//Testo dell'icona o della stringa semplice
  char *color;				//Colore del testo
  float alpha;				//Valore di Alpha dell'immagine (Serve per l'higlight del bottone al passaggio del mouse
  GLuint  texture;			//Testure Opengl in cui caricare l'immagine
  void *(function);			//CallBack del bottone
  char *param;				//1 parametro della callback
  float param2;				//2 parametro della callback
  char *tooltip;
}_UI_Button;

typedef struct {

  int id;
  char *name;
  _UI_Button *Button;

}_UI_Panel;

typedef struct {

  char name[50];

}_UI_PanelToShow;





_UI_Button interface[] = {

                           //0, 72, 32, 22, 2, "UI/images/mh.png",NULL,NULL,.8,0,_splashScreen,"",0,"Richiama lo splash screen",
                           //0, 32,32,79,2,"UI/images/open.png",NULL,"LIGHTBLUE",.8,0,_buildSliders,"head",0,"Per Questa versione di Test richiama i target della Testa",
                           //{0, 32,32,79,3,"UI/images/save.png",NULL,"LIGHTBLUE",.8,0,_buildSliders,"",0,"Not active in this relese"},
                           {0, 32,32,115,3,"UI/images/obj.png",NULL, NULL,.8,0,saveOBJ,"",0,"Export OBJ file"},
						   {0, 32,32,149,3,"UI/images/bSetting.png",NULL, NULL,.8,0,SaveBodysetting,"",0,"Save bodysettings file"},
                           {0, 32,32,183,3,"UI/images/reset.png",NULL, NULL,.8,0,reset_mesh,"",0,"Mesh reset - Remove all targets"},
                           //{0, 32,32,219,3,"UI/images/aqsis_p.png",NULL, NULL,.8,0,_render,"aqsis",0,"Preview AQSIS"},
                           {0, 32,32,217,3,"UI/images/pixie.png",NULL, NULL,.8,0,_render,"rndr",1,"Full Render PIXIE"},
                           {0, 32,32,251,3,"UI/images/aqsis.png",NULL, NULL,.8,0,_render,"aqsis",1,"Full Render AQSIS"},
                           //{0, 32,32,289,3,"UI/images/pixie_p.png",NULL, NULL,.8,0,_render,"rndr",0,"Preview PIXIE"},
                           //{0, 32,32,323,3,"UI/images/pixie.png",NULL, NULL,.8,0,_render,"rndr",1,"Full Render PIXIE"},
                           {0, 32,32,353,3,"UI/images/fullscreen.png",NULL, NULL,.8,0,_manageFullscreen,"",0,"Fullscreen in - out"},
                           {0, 32,32,387,3,"UI/images/anim.png",NULL, NULL,.8,0,_SS_anim,"",0,"Start/Stop Mesh animation"},
                           {0, 32,32,421,3,"UI/images/axis.png",NULL, NULL,.8,0,_manageAxis,"",0,"Axis on off"},
                           {0, 32,32,455,3,"UI/images/grid.png",NULL, NULL,.8,0,_manageGrid,"",0,"Grid on off"},
                           {0, 32,32,489,3,"UI/images/exit.png",NULL, NULL,.8,0,_switch,"ExitYN",0,"Close MakeHuman"},
                           {0, 200,32,557,3,"UI/images/logo.png",NULL, NULL,.8,0,_splashScreen,"",0,"About MakeHuman"},

                           {-1}

                         };

_UI_Button labels[] = {

                        {0, 78, 16, 73, 65, "UI/images/emptytab.png","Main","LIGHTBLUE",.8,0,_switch,"MHmain",0,"Main"},
                        {0, 78, 16, 73, 83, "UI/images/emptytab.png","Anatomy","LIGHTBLUE",.8,0,_switch,"anatomy",1,"Mesh Anatomy"},
                        {0, 78, 16, 73, 101, "UI/images/emptytab.png","NS Anatomy","LIGHTBLUE",.8,0,_switch,"NS_anatomy",2,"Non standard Mesh Anatomy - Fantasy"},
                        {0, 78, 16, 73, 119, "UI/images/emptytab.png","Emotions","LIGHTBLUE",.8,0,_switch,"mees",3,"Makehuman Emotion Expression System - based on FACS"},
                        {0, 78, 16, 73, 65, "UI/images/activetab.png",NULL,NULL,.8,0,NULL,"",0,""},

                        {-1}

                      };



_UI_Button MHmain[] = {

                        {0, 64, 64, 7, 64, "UI/images/weight.png",NULL,NULL,.8,0,_buildSliders,"weight",0,"undefined tooltip"},
                        {0, 64, 64, 7, 130, "UI/images/height.png",NULL,NULL,.8,0,_buildSliders,"types",0,"undefined tooltip"},
                        {0, 64, 64, 7, 196, "UI/images/age.png",NULL,NULL,.8,0,_buildSliders,"age",0,"undefined tooltip"},
                        {0, 64, 64, 7, 262, "UI/images/gender.png",NULL,NULL,.8,0,_buildSliders,"gender",0,"undefined tooltip"},
                        {0, 64, 64, 7, 328, "UI/images/muscle.png",NULL,NULL,.8,0,_buildSliders,"muscle",0,"undefined tooltip"},
                        {0, 64, 64, 7, 394, "UI/images/characters.png",NULL,NULL,.8,0,_buildSliders,"characters",0,"Characters"},
                        {-1}
                      };


_UI_Button anatomy[] = {

                         {0, 64, 27, 6, 64, "UI/anatomy/forehead.png",NULL,NULL,.8,0,_buildSliders,"forehead",0,"undefined tooltip"},
                         {0, 64, 14, 6, 91, "UI/anatomy/brows.png",NULL,NULL,.8,0,_buildSliders,"brow_ridge",0,"undefined tooltip"},
                         {0, 10, 44, 6, 105, "UI/anatomy/r_ear.png",NULL,NULL,.8,0,_buildSliders,"r_ear",0,"undefined tooltip"},
                         {0, 23, 25, 16, 105, "UI/anatomy/r_eye.png",NULL,NULL,.8,0,_buildSliders,"r_eye",0,"undefined tooltip"},                         
                         {0, 21, 25, 39, 105, "UI/anatomy/l_eye.png",NULL,NULL,.8,0,_buildSliders,"l_eye",0,"undefined tooltip"},
                         {0, 10, 44, 60, 105, "UI/anatomy/l_ear.png",NULL,NULL,.8,0,_buildSliders,"l_ear",0,"undefined tooltip"},
                         {0, 17, 19, 16, 130, "UI/anatomy/l_cheek.png",NULL,NULL,.8,0,_buildSliders,"l_cheek",0,"undefined tooltip"},
                         {0, 12, 19, 33, 130, "UI/anatomy/nose.png",NULL,NULL,.8,0,_buildSliders,"nose",0,"undefined tooltip"},
                         {0, 15, 19, 45, 130, "UI/anatomy/r_cheek.png",NULL,NULL,.8,0,_buildSliders,"r_cheek",0,"undefined tooltip"},                           
                         
                         {0, 64, 14, 6, 149, "UI/anatomy/mouth.png",NULL,NULL,.8,0,_buildSliders,"mouth",0,"undefined tooltip"},
                         {0, 64, 19, 6, 163, "UI/anatomy/chin_jaw.png",NULL,NULL,.8,0,_buildSliders,"chin_jaw",0,"undefined tooltip"},
                         
                         
                         {0, 64, 31, 6, 204, "UI/anatomy/fullhead.png",NULL,NULL,.8,0,_buildSliders,"head",0,"undefined tooltip"},
                         
                         {0, 25, 31, 6, 235, "UI/anatomy/r_shoulder.png",NULL,NULL,.8,0,_buildSliders,"r_shoulder",0,"undefined tooltip"},
                         {0, 14, 31, 31, 235, "UI/anatomy/neck.png",NULL,NULL,.8,0,_buildSliders,"neck",0,"undefined tooltip"},
                         {0, 25, 31, 45, 235, "UI/anatomy/l_shoulder.png",NULL,NULL,.8,0,_buildSliders,"l_shoulder",0,"undefined tooltip"},
                         
                         {0, 17, 23, 6, 266, "UI/anatomy/r_upper_arm.png",NULL,NULL,.8,0,_buildSliders,"r_upper_arm",0,"undefined tooltip"},
                         {0, 30, 23, 23, 266, "UI/anatomy/torso.png",NULL,NULL,.8,0,_buildSliders,"torso",0,"undefined tooltip"},
                         {0, 17, 23, 53, 266, "UI/anatomy/l_upper_arm.png",NULL,NULL,.8,0,_buildSliders,"l_upper_arm",0,"undefined tooltip"},
                         
                         
                         
                         
                         {0, 17, 48, 6, 289, "UI/anatomy/r_lower_arm.png",NULL,NULL,.8,0,_buildSliders,"r_lower_arm",0,"undefined tooltip"},
                         {0, 30, 23, 23, 289, "UI/anatomy/abdomen.png",NULL,NULL,.8,0,_buildSliders,"abdomen",0,"undefined tooltip"},
                         {0, 17, 48, 53, 289, "UI/anatomy/l_lower_arm.png",NULL,NULL,.8,0,_buildSliders,"l_lower_arm",0,"undefined tooltip"},
                         
                         
                         {0, 17, 25, 6, 337, "UI/anatomy/r_hand.png",NULL,NULL,.8,0,_buildSliders,"r_hand",0,"undefined tooltip"},
                         {0, 30, 25, 23, 312, "UI/anatomy/pelvis.png",NULL,NULL,.8,0,_buildSliders,"pelvis",0,"undefined tooltip"},
                         {0, 17, 25, 53, 337, "UI/anatomy/l_hand.png",NULL,NULL,.8,0,_buildSliders,"l_hand",0,"undefined tooltip"},
                         {0, 15, 54, 23, 337, "UI/anatomy/r_upper_leg.png",NULL,NULL,.8,0,_buildSliders,"r_upper_leg",0,"undefined tooltip"},
                         {0, 15, 54, 38, 337, "UI/anatomy/l_upper_leg.png",NULL,NULL,.8,0,_buildSliders,"l_upper_leg",0,"undefined tooltip"},
                         {0, 32, 60, 6, 391, "UI/anatomy/r_lower_leg.png",NULL,NULL,.8,0,_buildSliders,"r_lower_leg",0,"undefined tooltip"},
                         {0, 32, 60, 38, 391, "UI/anatomy/l_lower_leg.png",NULL,NULL,.8,0,_buildSliders,"l_lower_leg",0,"undefined tooltip"},
                         {0, 32, 20, 6, 451, "UI/anatomy/r_foot.png",NULL,NULL,.8,0,_buildSliders,"r_foot",0,"undefined tooltip"},
                         {0, 32, 20, 38, 451, "UI/anatomy/l_foot.png",NULL,NULL,.8,0,_buildSliders,"l_foot",0,"undefined tooltip"},


                         {-1}
                       };


_UI_Button NS_anatomy[] = {

                         {0, 64, 27, 6, 64, "UI/ns_anatomy/forehead.png",NULL,NULL,.8,0,_buildSliders,"ns_forehead",0,"undefined tooltip"},
                         {0, 64, 14, 6, 91, "UI/ns_anatomy/brows.png",NULL,NULL,.8,0,_buildSliders,"ns_brow_ridge",0,"undefined tooltip"},
                         {0, 10, 44, 6, 105, "UI/ns_anatomy/r_ear.png",NULL,NULL,.8,0,_buildSliders,"ns_r_ear",0,"undefined tooltip"},
                         {0, 23, 25, 16, 105, "UI/ns_anatomy/r_eye.png",NULL,NULL,.8,0,_buildSliders,"ns_r_eye",0,"undefined tooltip"},                         
                         {0, 21, 25, 39, 105, "UI/ns_anatomy/l_eye.png",NULL,NULL,.8,0,_buildSliders,"ns_l_eye",0,"undefined tooltip"},
                         {0, 10, 44, 60, 105, "UI/ns_anatomy/l_ear.png",NULL,NULL,.8,0,_buildSliders,"ns_l_ear",0,"undefined tooltip"},
                         {0, 17, 19, 16, 130, "UI/ns_anatomy/r_cheek.png",NULL,NULL,.8,0,_buildSliders,"ns_r_cheek",0,"undefined tooltip"},
                         {0, 12, 19, 33, 130, "UI/ns_anatomy/nose.png",NULL,NULL,.8,0,_buildSliders,"ns_nose",0,"undefined tooltip"},
                         {0, 15, 19, 45, 130, "UI/ns_anatomy/l_cheek.png",NULL,NULL,.8,0,_buildSliders,"ns_l_cheek",0,"undefined tooltip"},                           
                         
                         {0, 64, 14, 6, 149, "UI/ns_anatomy/mouth.png",NULL,NULL,.8,0,_buildSliders,"ns_mouth",0,"undefined tooltip"},
                         {0, 64, 19, 6, 163, "UI/ns_anatomy/chin_jaw.png",NULL,NULL,.8,0,_buildSliders,"ns_chin_jaw",0,"undefined tooltip"},
                         
                         
                         {0, 64, 31, 6, 204, "UI/ns_anatomy/fullhead.png",NULL,NULL,.8,0,_buildSliders,"ns_head",0,"undefined tooltip"},
                         
                         {0, 25, 31, 6, 235, "UI/ns_anatomy/r_shoulder.png",NULL,NULL,.8,0,_buildSliders,"ns_r_shoulder",0,"undefined tooltip"},
                         {0, 14, 31, 31, 235, "UI/ns_anatomy/neck.png",NULL,NULL,.8,0,_buildSliders,"ns_neck",0,"undefined tooltip"},
                         {0, 25, 31, 45, 235, "UI/ns_anatomy/l_shoulder.png",NULL,NULL,.8,0,_buildSliders,"ns_l_shoulder",0,"undefined tooltip"},
                         
                         {0, 17, 23, 6, 266, "UI/ns_anatomy/r_upper_arm.png",NULL,NULL,.8,0,_buildSliders,"ns_r_upper_arm",0,"undefined tooltip"},
                         {0, 30, 23, 23, 266, "UI/ns_anatomy/torso.png",NULL,NULL,.8,0,_buildSliders,"ns_torso",0,"undefined tooltip"},
                         {0, 17, 23, 53, 266, "UI/ns_anatomy/l_upper_arm.png",NULL,NULL,.8,0,_buildSliders,"ns_l_upper_arm",0,"undefined tooltip"},
                         
                         
                         
                         
                         {0, 17, 48, 6, 289, "UI/ns_anatomy/r_lower_arm.png",NULL,NULL,.8,0,_buildSliders,"ns_r_lower_arm",0,"undefined tooltip"},
                         {0, 30, 23, 23, 289, "UI/ns_anatomy/abdomen.png",NULL,NULL,.8,0,_buildSliders,"ns_abdomen",0,"undefined tooltip"},
                         {0, 17, 48, 53, 289, "UI/ns_anatomy/l_lower_arm.png",NULL,NULL,.8,0,_buildSliders,"ns_l_lower_arm",0,"undefined tooltip"},
                         
                         
                         {0, 17, 25, 6, 337, "UI/ns_anatomy/r_hand.png",NULL,NULL,.8,0,_buildSliders,"ns_r_hand",0,"undefined tooltip"},
                         {0, 30, 25, 23, 312, "UI/ns_anatomy/pelvis.png",NULL,NULL,.8,0,_buildSliders,"ns_pelvis",0,"undefined tooltip"},
                         {0, 17, 25, 53, 337, "UI/ns_anatomy/l_hand.png",NULL,NULL,.8,0,_buildSliders,"ns_l_hand",0,"undefined tooltip"},
                         {0, 15, 54, 23, 337, "UI/ns_anatomy/r_upper_leg.png",NULL,NULL,.8,0,_buildSliders,"ns_r_upper_leg",0,"undefined tooltip"},
                         {0, 15, 54, 38, 337, "UI/ns_anatomy/l_upper_leg.png",NULL,NULL,.8,0,_buildSliders,"ns_l_upper_leg",0,"undefined tooltip"},
                         {0, 32, 60, 6, 391, "UI/ns_anatomy/r_lower_leg.png",NULL,NULL,.8,0,_buildSliders,"ns_r_lower_leg",0,"undefined tooltip"},
                         {0, 32, 60, 38, 391, "UI/ns_anatomy/l_lower_leg.png",NULL,NULL,.8,0,_buildSliders,"ns_l_lower_leg",0,"undefined tooltip"},
                         {0, 32, 20, 6, 451, "UI/ns_anatomy/r_foot.png",NULL,NULL,.8,0,_buildSliders,"ns_r_foot",0,"undefined tooltip"},
                         {0, 32, 20, 38, 451, "UI/ns_anatomy/l_foot.png",NULL,NULL,.8,0,_buildSliders,"ns_l_foot",0,"undefined tooltip"},


                         {-1}
                       };

_UI_Button fantasy[] = {
                         {0, 64, 64, 8, 64, "UI/images/wip.png",NULL,NULL,.8,0,_buildSliders,"head_fantasy",0,"Teste Fantasy"},
                         {0, 64, 64, 8, 130, "UI/images/wip.png",NULL,NULL,.8,0,_buildSliders,"hands_fantasy",0,"Mani Fantasy"},
                         {0, 64, 64, 8, 196, "UI/images/wip.png",NULL,NULL,.8,0,_buildSliders,"characters",0,"Characters"},
                         {-1}
                       };


_UI_Button mees[] = {

                      {0, 64, 64, 8, 64, "UI/images/wip.png",NULL,NULL,.8,0,_buildSliders,"mees_builders",0,"MEES1 Work in progress"},
                      {0, 64, 64, 8, 130, "UI/images/wip.png",NULL,NULL,.8,0,_buildSliders,"mees_emotions",0,"Eyes movement Work in progress"},
                      {0, 64, 64, 8, 196, "UI/images/wip.png",NULL,NULL,.8,0,_buildSliders,"mees_gesture",0,"MEES2 Work in progress"},
                      {0, 64, 64, 8, 262, "UI/images/wip.png",NULL,NULL,.8,0,_buildSliders,"mees_movements",0,"MEES3 Work in progress"},
                      {-1}
                    };

_UI_Button ExitYN[] = {

                        {0, 64, 64, 7, 196, "UI/images/yes.png",NULL,NULL,.8,0,_exitYN,"",1,"Confirm Exit"},
                        {0, 64, 64, 7, 262, "UI/images/no.png",NULL,NULL,.8,0,_exitYN,"",0,"No thanks"},
                        //{0, 200, 96,200,100,"UI/images/alert_bg.png", NULL, NULL, .8,0,NULL, "", 0, ""},
                        //{0,0,0,215, 115, NULL, "ARE YOU SURE TO EXIT?", "BLACK", .8,0,NULL,"",0,""},
                        //{0, 56, 16, 240, 150, "UI/images/emptytab.png","Yes","LIGHTBLUE",.8,0,_exitYN,"",1,"Esce dal programma"},
                        //{0, 56, 16, 300, 150, "UI/images/emptytab.png","No","LIGHTBLUE",.8,0,_exitYN,"",0,"Annulla"},

                        {-1}

                      };

_UI_Button splash_screen[] = {

                        {0,512,256,200,100,"UI/images/splash.png", "", "LIGHTBLUE", .8,0,close_splash, "", 0, ""},
                        //{0,0,0,10, 10, NULL, "Version: ", "LIGHTBLUE", .8,0,NULL,"",0,""},
                        {-1}

                      };


_UI_Panel Panels[] = {

                       {0, "interface", interface},
                       {1, "labels", labels},
                       {2, "MHmain", MHmain},
                       {3, "anatomy", anatomy},
                       {4, "fantasy", fantasy},
                       {5, "mees", mees},
                       {6, "ExitYN", ExitYN},
                       {7, "NS_anatomy", NS_anatomy},
                       {8, "splash_screen", splash_screen},
                     };

_UI_PanelToShow PanelsToShow[] = {

                                   {"interface"},
                                   {"labels"},
                                   {"MHmain"} ,

                                 };




pngInfo info;
GLuint  texture;


int cellDisp = 0;
int numOfTargets = 0;
extern int anim;

double PI = 3.1415926535897932384626433832795;
float ACTIVE = 1.0;
float IDLE = 0.8;


GLint selection = 0;
GLint showBig = 0;
GLint showTip = 0;
GLint showHelp = 0;

cell **TargetSliders; //

GLvoid *font_style = GLUT_BITMAP_HELVETICA_10;

void setfont(char* name, int size)
{
  font_style = GLUT_BITMAP_HELVETICA_10;
  if (strcmp(name, "helvetica") == 0) {
    if (size == 12)
      font_style = GLUT_BITMAP_HELVETICA_12;
    else if (size == 18)
      font_style = GLUT_BITMAP_HELVETICA_18;
  } else if (strcmp(name, "times roman") == 0) {
    font_style = GLUT_BITMAP_TIMES_ROMAN_10;
    if (size == 24)
      font_style = GLUT_BITMAP_TIMES_ROMAN_24;
  } else if (strcmp(name, "8x13") == 0) {
    font_style = GLUT_BITMAP_8_BY_13;
  } else if (strcmp(name, "9x15") == 0) {
    font_style = GLUT_BITMAP_9_BY_15;
  }
}

void drawstr(GLuint x, GLuint y, char* format, ...)
{
  va_list args;
  char buffer[255], *s;

  va_start(args, format);
  vsprintf(buffer, format, args);
  va_end(args);

  glRasterPos2i(x, y);
  for (s = buffer; *s; s++)
    glutBitmapCharacter(font_style, *s);
}


void cell_draw(cell* cell, int w, int h);
int cell_hit(cell* cell, int x, int y);
void cell_update(cell* cell, int update);

void cell_draw(cell* cell, int w, int h)
{
  float r,g,b,al;
  int tipx, tipy;
  r=.37;
  g=.56;
  b=.71;
  al= 1;
  if (cell->type == 2){
    r = .9;
    g = .3;
    b = .3;
  }
  if (cell->imgOffsetX > 3){
    DrawRoundedSquareFill(cell->x-cell->imgOffsetX, cell->y-cell->imgOffsetY, 3, cell->w, cell->h, r, g, b);
  }
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D, cell->texture);
  glColor4f(1, 1, 1, cell->alpha);
  glBegin(GL_QUADS);
  glTexCoord2f(0, 0); glVertex2f( cell->x-cell->imgOffsetX, cell->y-cell->imgOffsetY);
  glTexCoord2f(0, 1); glVertex2f( cell->x-cell->imgOffsetX, cell->y-cell->imgOffsetY + cell->h);
  glTexCoord2f(1, 1); glVertex2f(cell->x-cell->imgOffsetX+cell->w,  cell->y-cell->imgOffsetY + cell->h);
  glTexCoord2f(1, 0); glVertex2f(cell->x-cell->imgOffsetX+cell->w, cell->y-cell->imgOffsetY);
  glEnd();
  glDisable(GL_TEXTURE_2D);

  if (cell->value>0){
    r=.95;
    g=.17;
    b=.17;
    glColor3f(r, g, b);
  }else glColor4f(r, g, b, al);

  if (showBig == cell->id) {
    if (cell->infox< w-(strlen(cell->info)*6)+10){
      tipx = cell->x + cell->w - cell->imgOffsetX;
      tipy = cell->y - (cell->imgOffsetY + 2);
    }else{
      tipx = cell->x - cell->w-cell->imgOffsetX;
      tipy = cell->y - (cell->imgOffsetY+2);
    }
    DrawSquareFill(tipx, tipy, 4+(strlen(cell->info)*6)+4, 18, .9, .9, .6, .6);
    glColor4f(0, 0, 0, al);
    substitute_char(cell->info, '_', ' ');
    drawstr(tipx+10, cell->y-(cell->imgOffsetY+8), cell->info);
    glColor4f(r, g, b, al);
  }
  if (showHelp == cell->id) {
    drawstr(90, 48, cell->help);
  }
  if(cell->type == 1){
    drawstr(cell->x, cell->y, cell->format, cell->value);
  }
}

int cell_hit(cell* cell, int x, int y)
{
  if (x > cell->x && x < cell->x + cell->w && y > cell->y - cell->h && y < cell->y){
    if(cell->type == 1){
      Load_Target(cell->target);
      return cell->id;
    }else{
      LoadBodysetting(cell->target);
      return 0;
    }
  }
  return 0;
}

void cell_update(cell* cell, int update)
{
  if (selection != cell->id)
    return;

  cell->value += update * cell->step;
  if (cell->value < cell->min)
    cell->value = cell->min;
  else if (cell->value > cell->max)
    cell->value = cell->max;
}


void PrintText(int x, int y, char *text, char *color)
{
  glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);
  if (!strcmp(color, "LIGHTBLUE"))glColor3f(LIGHTBLUE);
  if (!strcmp(color, "BLACK"))glColor3f(BLACK);
  drawstr(x,y,text);
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_BLEND);

}

void PrintLabel(int x, int y, char *text, char *color)
{
  glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);
  if (!strcmp(color, "LIGHTBLUE"))glColor3f(LIGHTBLUE);
  if (!strcmp(color, "BLACK"))glColor3f(BLACK);
  drawstr(x,y,text);
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_BLEND);

}

GLuint load_texture(char *file){

  texture = pngBind(file, PNG_NOMIPMAP, PNG_ALPHA, &info, GL_CLAMP, GL_NEAREST, GL_LINEAR);
  if (texture == 0) {
    printf("Can't load file: %s\n", file);
    //texture = pngBind("UI/tgimg/no_img.png", PNG_NOMIPMAP, PNG_ALPHA, &info, GL_CLAMP, GL_NEAREST, GL_LINEAR);
    //exit(1);
    return texture;
  }

  return texture;
}


void SetUP_UI(void){

  int i, c, d = 1;

  for(i=0; i<(sizeof(Panels)/sizeof(Panels[0])); i++){
    c = 0;
    while(Panels[i].Button[c].id != -1)
    {
      Panels[i].Button[c].id = d;
#ifdef HAVE_CONFIG_H
      char tmp[MAX_PATH];
      strcpy (tmp, PACKAGE_DATA_DIR"/");
      strcat (tmp, Panels[i].Button[c].image);
      if(Panels[i].Button[c].image) Panels[i].Button[c].texture = load_texture(tmp);
#else
      if(Panels[i].Button[c].image) Panels[i].Button[c].texture = load_texture(Panels[i].Button[c].image);
#endif
      c++;
      d++;
    }

  }

}


void _select(char *a, float b, void(*operaz)(char *, float))
/* applica tra a e b la funzione puntata da operaz */
{
  operaz(a, b);
}


void _freeSliders(void){

  int c;
  for(c=0; c<numOfTargets; c++){
    free(TargetSliders[c]->target);
    free(TargetSliders[c]->format);
    free(TargetSliders[c]->info);
    free(TargetSliders[c]->image);
    glDeleteTextures(1, &TargetSliders[c]->texture);
    free(TargetSliders[c]);
  }
  free(TargetSliders);
  TargetSliders = NULL;
}

void _buildSliders(char *a, float b)
{
  static char *activepart = NULL;
  int i, c;

  char buffer[80];

  if (b && cellDisp!=0){
    showHelp = 0;
    showBig = 0;
    _freeSliders();
    _buildSliders(activepart, 0);
    return;
  }

  cellDisp = 0;
  for(i = 0; i<counterDir; i++){
    if(strcmp(targetList[i].dirName, a) == 0){
      if(!TargetSliders){
        TargetSliders = (cell **)malloc(targetList[i].numOfTargets*sizeof(cell *));
        if(TargetSliders == NULL)
          exit(1);
        numOfTargets = targetList[i].numOfTargets;
        cellDisp = numOfTargets;

        for(c=0; c<targetList[i].numOfTargets; c++){
          TargetSliders[c] = (cell *)malloc(sizeof(cell));
          TargetSliders[c]->id = c+1;
          TargetSliders[c]->x = 0; //42+(c*36);
          TargetSliders[c]->y = 0;
          TargetSliders[c]->w = 32;
          TargetSliders[c]->h = 32;
          TargetSliders[c]->imgOffsetY = 42;
          TargetSliders[c]->imgOffsetX = 3;
          TargetSliders[c]->image = malloc((strlen(targetList[i].targetNames[c])+1)*sizeof(char));
          strcpy(buffer, targetList[i].targetNames[c]);
          strcpy(TargetSliders[c]->image,strtok(buffer, "."));

          if (strcmp(strtok(NULL, "."), "bs")== 0)
            TargetSliders[c]->type = 2;
          else
            TargetSliders[c]->type = 1;

          TargetSliders[c]->alpha = .8;

          //if(TargetSliders[c]->type == 1){
            strcpy(buffer, IMAGE_DIR);
            strcat(buffer, targetList[i].dirName);
            strcat(buffer, "/");
            strcat(buffer, TargetSliders[c]->image);
            strcat(buffer, ".png");
            TargetSliders[c]->texture = load_texture(buffer);
          //}else{
          //  TargetSliders[c]->texture = load_texture("UI/images/bSetting.png");
          //}

          TargetSliders[c]->min = 0.0;
          TargetSliders[c]->max = 1.0;
          TargetSliders[c]->value = 0.0;
          TargetSliders[c]->step = 0.01;
          TargetSliders[c]->info = malloc((strlen(targetList[i].targetNames[c])+1)*sizeof(char));
          strcpy(TargetSliders[c]->info,targetList[i].targetNames[c]);
          TargetSliders[c]->format = malloc((strlen("%.3f")+1)*sizeof(char));
          strcpy(TargetSliders[c]->format,"%.3f");

          if(TargetSliders[c]->type == 1){
            TargetSliders[c]->help = malloc((strlen(CELLHELP)+1)*sizeof(char));
            strcpy(TargetSliders[c]->help,CELLHELP);
          }else {
            TargetSliders[c]->help = malloc((strlen(BS_HELP)+1)*sizeof(char));
            strcpy(TargetSliders[c]->help,BS_HELP);
          }

          TargetSliders[c]->target = malloc((strlen(DATA_DIR)+strlen(targetList[i].targetNames[c])+strlen(targetList[i].dirName)+3)*sizeof(char));
          strcpy(TargetSliders[c]->target,DATA_DIR);
          strcat(TargetSliders[c]->target,targetList[i].dirName);
          strcat(TargetSliders[c]->target,"/");
          strcat(TargetSliders[c]->target,targetList[i].targetNames[c]);
          if(isInList(TargetSliders[c]->target, TargetUsed)){
            TargetSliders[c]->value = getValue(TargetSliders[c]->target, TargetUsed);
          }
        }
        activepart = a;
      }
      else{
        _freeSliders();
        _buildSliders(a, b);
      }break;

    }

  }
}


void reset_mesh(char *a , float b){

  setToZero(TargetUsed);
  calculate_vertex_normal();
  _buildSliders("", 1);

}


void DrawCircle(){

  float angle;
  int i;
  GLint circle_points = 100;
  glColor4f(1, 0, 0, .8);
  glBegin(GL_LINE_LOOP);

  for (i = 0; i < circle_points; i++) {
    angle = 2*PI*i/circle_points;
    glVertex2f(cos(angle), sin(angle));
  }

  glEnd();
}

void DrawSquareFill(float x, float y, float width, float height, float r, float g, float b, float alpha) {

  glColor4f(r, g, b, alpha);

  glBegin(GL_POLYGON);
  glVertex2f(x,y);
  glVertex2f(x,y-height);
  glVertex2f(x+width, y-height);
  glVertex2f(x+width, y);
  glEnd();
  glColor4f(1, 1, 1, alpha);
  glBegin(GL_LINE_STRIP);
  glVertex2f(x,y);
  glVertex2f(x,y-height);
  glVertex2f(x+width, y-height-1);
  glVertex2f(x+width, y);
  glVertex2f(x,y);
  glEnd();

}
void DrawRoundedSquareFill(float x, float y, float radius, float width, float height, float r, float g, float b)
{
  float cX = x+radius, cY = y+radius;
  double i=0;
  double gap = .05;

  glColor4f(r, g, b, .6);
  glBegin(GL_POLYGON);
  glVertex2f(x, y + height - radius);//Left Line
  glVertex2f(x, y + radius);

  for(i = PI; i <= (1.5*PI); i += gap)
  {
    glVertex2d(radius* cos(i) + cX, radius * sin(i) + cY); //Top Left
  }

  glVertex2f(x + radius, y);
  glVertex2f(x + width - radius, y);//Top Line

  cX = x+width-radius;
  for(i = (1.5*PI); i <= (2 * PI); i += gap)
  {
    glVertex2d(radius* cos(i) + cX, radius * sin(i) + cY); //Top Right
  }

  glVertex2f(x + width, y + radius);
  glVertex2f(x + width, y + height - radius);//Right Line

  cY = y+height-radius;
  for(i = 0; i <= (0.5*PI); i+=gap)
  {
    glVertex2d(radius* cos(i) + cX, radius * sin(i) + cY); //Bottom Right
  }
  glVertex2f(x + width - radius, y + height);//Bottom Line
  glVertex2f(x + radius, y + height);


  cX = x+radius;
  for(i = (0.5*PI); i <= PI; i += gap)
  {
    glVertex2d(radius* cos(i) + cX, radius * sin(i) + cY);//Bottom Left
  }
  glEnd();
}

void Draw_Cells(int w, int h){

  int i;
  int offsetx = 5;
  int offsety = 24;
  int numDisp;
  int counter = 0;

  if (cellDisp){
    numDisp = (w-116)/36;

    //DrawRoundedSquareFill(72, h-(24+(numOfTargets/numDisp+1)*48), 5, w-108, (numOfTargets/numDisp+1)*52, .1, .1, .1);
    DrawRoundedSquareFill(72, h-(24+(numOfTargets/numDisp+1)*48), 5, w-108, (numOfTargets/numDisp+1)*52, .1, .1, .1);
    for(i=0;i<numOfTargets; i++){
      if (counter>=numDisp){
        counter = 0;
        offsety += 45;
        offsetx -= 36*numDisp;
      }
      TargetSliders[i]->x = 78+offsetx;
      TargetSliders[i]->y = h-offsety;
      cell_draw(TargetSliders[i], w,h);
      offsetx+= 36;
      counter++;
    }
    if (showBig){
      cell_draw(TargetSliders[showBig-1], w, h);
    }
  }
}



int check(char *a){

  int i;
  for(i=0; i<(sizeof(PanelsToShow)/sizeof(PanelsToShow[0])); i++){
    if(!strcmp(a, PanelsToShow[i].name)) return 1;
  }
  return 0;
}

void Draw_UI(int w, int h)
{

  int i, c;


  glPushAttrib(GL_POLYGON_BIT);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glEnable(GL_TEXTURE_2D);
  glEnable(GL_BLEND);
  glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
  //glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);

  for(i=0; i<(sizeof(Panels)/sizeof(Panels[0])); i++){
    if (check(Panels[i].name)){
      c = 0;
      while(Panels[i].Button[c].id != -1)
      {
        if (Panels[i].Button[c].image){
          glBindTexture(GL_TEXTURE_2D, Panels[i].Button[c].texture);
          glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
          glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
          glColor4f(1, 1, 1, Panels[i].Button[c].alpha);
          glBegin(GL_QUADS);
          glTexCoord2f(0, 0); glVertex2f(Panels[i].Button[c].x, Panels[i].Button[c].y);
          glTexCoord2f(0, 1); glVertex2f( Panels[i].Button[c].x, Panels[i].Button[c].y + Panels[i].Button[c].h);
          glTexCoord2f(1, 1); glVertex2f(Panels[i].Button[c].x+Panels[i].Button[c].w,  Panels[i].Button[c].y + Panels[i].Button[c].h);
          glTexCoord2f(1, 0); glVertex2f(Panels[i].Button[c].x+Panels[i].Button[c].w, Panels[i].Button[c].y );
          glEnd();

          if(Panels[i].Button[c].text){
            PrintLabel(Panels[i].Button[c].x+4, Panels[i].Button[c].y+Panels[i].Button[c].h-4, Panels[i].Button[c].text, Panels[i].Button[c].color);
          }
        }else{
          PrintText(Panels[i].Button[c].x, Panels[i].Button[c].y, Panels[i].Button[c].text, Panels[i].Button[c].color);
        }
        if(showTip == Panels[i].Button[c].id){
          glDisable(GL_BLEND);
          glDisable(GL_TEXTURE_2D);
          drawstr(90, 48, Panels[i].Button[c].tooltip);
          glEnable(GL_BLEND);
          glEnable(GL_TEXTURE_2D);
        }
        c++;
      }
    }

  }

  glDisable(GL_TEXTURE_2D);
  Draw_Cells(w,h);

  glDisable(GL_BLEND);
  glPopAttrib();



}

void OnSlider(int x, int y){
  int i;
  selection = 0;
  for(i=0;i<numOfTargets; i++){
    selection += cell_hit(TargetSliders[i], x, y);
    if (selection) break;
  }
  glutPostRedisplay();
}

void sliderUpdate(int oldpos, int pos){

  if (selection){
    cell_update(TargetSliders[selection-1], pos-oldpos);
    Do_Morph(TargetSliders[selection-1]->target, TargetSliders[selection-1]->value);
    calculate_vertex_normal ();
    glutPostRedisplay();
  }

}

void OnRelease(void){
  selection = 0;
  glutPostRedisplay();
}

void OnClick(int x, int y){

  int i, c;

  for(i=0; i<(sizeof(Panels)/sizeof(Panels[0])); i++){
    c = 0;
    if (check(Panels[i].name)){
      while(Panels[i].Button[c].id != -1)
      {
        if(Panels[i].Button[c].function){
          if(x > Panels[i].Button[c].x && x < Panels[i].Button[c].x + Panels[i].Button[c].w && y > Panels[i].Button[c].y && y < Panels[i].Button[c].y + Panels[i].Button[c].h){
            _select(Panels[i].Button[c].param, Panels[i].Button[c].param2, Panels[i].Button[c].function);
            break;
          }
        }
        c++;
      }
    }
  }
}

void OnOver(int x, int y){

  int i,c;

  for(i=0; i<(sizeof(Panels)/sizeof(Panels[0])); i++){
    c = 0;
    if (check(Panels[i].name)){
      while(Panels[i].Button[c].id != -1)
      {
        if(Panels[i].Button[c].function){
          if(x > Panels[i].Button[c].x && x < Panels[i].Button[c].x + Panels[i].Button[c].w && y > Panels[i].Button[c].y && y < Panels[i].Button[c].y + Panels[i].Button[c].h){
            if(Panels[i].Button[c].alpha != ACTIVE){
              showTip = Panels[i].Button[c].id;
              Panels[i].Button[c].alpha = ACTIVE;
              //Panels[i].Button[c].x -= 1;
              //Panels[i].Button[c].w += 2;
              //Panels[i].Button[c].y -= 1;
              //Panels[i].Button[c].h += 2;

              glutPostRedisplay();
            }

          }else if(Panels[i].Button[c].alpha == ACTIVE){
              showTip = 0;
              Panels[i].Button[c].alpha = IDLE;
              //Panels[i].Button[c].x += 1;
              //Panels[i].Button[c].w -= 2;
              //Panels[i].Button[c].y += 1;
              //Panels[i].Button[c].h -= 2;

              glutPostRedisplay();
            //}
          }
        }
        c++;
      }
    }
  }


  if (cellDisp){
    for(i=0; i<numOfTargets; i++){
      if (x > TargetSliders[i]->x && x < TargetSliders[i]->x + 32 && y > TargetSliders[i]->y - 42 && y < TargetSliders[i]->y){
        if(TargetSliders[i]->alpha != ACTIVE){
          showBig = TargetSliders[i]->id;
          showHelp = TargetSliders[i]->id;
          selection = TargetSliders[i]->id;
          TargetSliders[i]->alpha = ACTIVE;
          //TargetSliders[i]->x -= 8;
          TargetSliders[i]->w += 32;
          //TargetSliders[i]->y -= 2;
          TargetSliders[i]->h += 32;
          TargetSliders[i]->imgOffsetX += 16;
          TargetSliders[i]->imgOffsetY += 32;
          TargetSliders[i]->infox = x;
          TargetSliders[i]->infoy = y;
          glutPostRedisplay();
        }
      }
      else{
        if(TargetSliders[i]->alpha == ACTIVE){
          showBig = 0;
          showHelp = 0;
          selection = 0;
          TargetSliders[i]->alpha = IDLE;
          //TargetSliders[i]->x += 8;
          TargetSliders[i]->w -= 32;
          //TargetSliders[i]->y += 2;
          TargetSliders[i]->h -= 32;
          TargetSliders[i]->imgOffsetX -= 16;
          TargetSliders[i]->imgOffsetY -= 32;
          glutPostRedisplay();
        }
      }

    }
  }
}


//  ******************************************************************************************
// Function name:       void _splashScreen(char *a , float b)
// slpalshscreen callback
//  ******************************************************************************************
void _splashScreen(char *a , float b){

  extern int wi, hi;

  int xpos = wi/2 - splash_screen[0].w/2;
  int ypos = hi/2 - splash_screen[0].h/2;
  splash_screen[0].x = xpos;
  splash_screen[0].y = ypos;
  splash_screen[0].text = MHTITLE VERSION;

  _switch("splash_screen", 0);

}

void _switch(char *a, float b){

  int i;
  i = sizeof(labels)/sizeof(labels[0]);
  strcpy(PanelsToShow[2].name, a);
  labels[i-2].y = labels[(int)(b)].y+1;

}

void _exitYN(char *a, float b){
  if (b){
    exit(0);
  }

  else{
    _switch("MHmain", 0);
  }
}

void _manageFullscreen(char *a, float b)
{
	toggle_fullscreen();
}

void _SS_anim(char *a, float b){

  if (anim == 0){
    anim = 1;
  }
  else{

    anim = 0;
  }
}

void _manageAxis(char *a, float b){

  extern int axis;
  axis = !axis;
}
void _manageGrid(char *a, float b){

  extern int grid;
  grid = !grid;
}

void _render(char *a, float b){

  extern int wi, hi;
  if(strcmp(a, "aqsis")==0){
    if(b>0)	MakeRib(1, "fullSize.rib", "fullSize.tif", wi, hi, "aqsis");
    else MakeRib(1, "fullSize.rib", "fullSize.tif", 300, 300, "aqsis");
  }
  if(strcmp(a, "rndr")==0){
    if(b>0)	MakeRib(1, "fullSize.rib", "fullSize.tif", wi, hi, "rndr");
    else MakeRib(1, "fullSize.rib", "fullSize.tif", 300, 300, "rndr");
  }
}

void setOrthographicProjection(int wi, int hi) {

  // switch to projection mode
  glDisable(GL_LIGHTING);
  glDisable(GL_DEPTH_TEST);
  glPushMatrix();
  glMatrixMode(GL_PROJECTION);
  // save previous matrix which contains the
  //settings for the perspective projection
  glPushMatrix();
  // reset matrix
  glLoadIdentity();
  // set a 2D orthographic projection
  //gluOrtho2D(0, wi, 0, hi);
  glOrtho(0, wi, 0, hi, -1, 2);
  // invert the y axis, down is positive
  glScalef(1, -1, 1);
  // mover the origin from the bottom left corner
  // to the upper left corner
  glTranslatef(0, -hi, 0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
}

void resetPerspectiveProjection() {
  glPopMatrix();
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);
  glEnable(GL_LIGHTING);
  glEnable(GL_DEPTH_TEST);
}

void togglewire(void) {
  static int toggle = 0;
  toggle ^= 1;
  glPolygonMode(GL_FRONT_AND_BACK, toggle ? GL_LINE : GL_FILL);
  glutPostRedisplay();
}

void Draw_Axis()
{
  float wid = 2.8;
  extern int grid;
  char axis[]= "XYZ";
  glDisable(GL_LIGHTING);

  if(grid) glDisable(GL_DEPTH_TEST);
  glBegin(GL_LINES);

  glColor3f(.5, 1, .5);
  glVertex3f(0, 0, -wid);
  glVertex3f(0, 0, wid);
  glColor3f(.5, .5, 1);
  glVertex3f(-wid, 0, 0);
  glVertex3f(wid, 0, 0);
  glColor3f(1, .5, .5);
  glVertex3f(0,-wid, 0);
  glVertex3f(0, wid, 0);
  glEnd();
  glPushMatrix();
  glTranslatef(0,wid,0);
  glRasterPos2f(.05, .05);
  glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, axis[1]);
  glRotatef(-90, 1,0,0);
  glutSolidCone(.03,.1,8,4);
  glPopMatrix();
  glPushMatrix();
  glColor3f(.5, .5, 1);
  glTranslatef(wid,0,0);
  glRasterPos2f(.05, .05);
  glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, axis[0]);
  glRotatef(90, 0,1,0);
  glutSolidCone(.03,.1,8,4);
  glPopMatrix();
  glPushMatrix();
  glColor3f(.5, 1, .5);
  glTranslatef(0,0,wid);
  glRasterPos2f(.05, .05);
  glutBitmapCharacter(GLUT_BITMAP_HELVETICA_12, axis[2]);
  glRotatef(90, 0,0,1);
  glutSolidCone(.03,.1,8,4);
  glPopMatrix();

  if(grid) glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);
}

void Draw_Grid()
{

  float i;
  float dens = 5;
  glDisable(GL_LIGHTING);
  glColor3f(.15, .15, .15);
  for(i = -dens; i <= dens; i += .2){
    glBegin(GL_LINES);
    glVertex3f(-dens, 0, i);
    glVertex3f(dens, 0, i);
    glVertex3f(i, 0,-dens);
    glVertex3f(i, 0, dens);
    glEnd();
  }
  glEnable(GL_LIGHTING);
}




void Draw_Decoration(int wi,int hi){

  glPushAttrib(GL_POLYGON_BIT);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glEnable(GL_BLEND);
  glBegin(GL_POLYGON);
  glColor4f(.3, .5, .68, .6);
  glVertex2f(5, 36);
  glVertex2f(5, 1);
  //glVertex2f(wi-5, 36);
  glColor4f(.37, .56, .71, .2);
  glVertex2f(wi-5, 1);
  glVertex2f(wi-5, 36);
  //glVertex2f(5, 1);
  glEnd();
  glBegin(GL_POLYGON);
  glColor4f(.3, .3, .3, .6);
  glVertex2f(5, 500);
  glVertex2f(5, 36);
  //glVertex2f(wi-5, 36);
  glColor4f(.3, .3, .3, .4);
  glVertex2f(72, 36);
  glVertex2f(72, 500);
  //glVertex2f(5, 1);
  glEnd();


  glDisable(GL_BLEND);
  glColor3f(.37, .56, .71);
  glBegin(GL_LINE_STRIP);
  glVertex2f(72, hi-36);
  glVertex2f(5, hi-36);
  glVertex2f(5, 36);
  //glVertex2f(72, 18);
  //glVertex2f(72, 36);
  glVertex2f(wi-5, 36);
  glVertex2f(wi-5, hi-36);
  glVertex2f(wi-36, hi-36);
  glEnd();
  glBegin(GL_LINE_STRIP);
  glVertex2f(5, 36);
  glVertex2f(72, 36);
  glVertex2f(72, 500);
  glVertex2f(5, 500);
  //glVertex2f(wi-5, hi-36);
  //glVertex2f(wi-36, hi-36);
  glEnd();

  glPopAttrib();
}



void Draw_Decoration2(int wi, int hi){

  float radius = 35;
  double PI = 3.1415926535897932384626433832795;
  //loat cX = x+radius, cY = y+radius;
  double i=0;
  double gap = .05;

  glPushAttrib(GL_POLYGON_BIT);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  glEnable(GL_BLEND);

  glBegin(GL_POLYGON);

  glColor4f(.3, .5, .68, .4);
  glVertex2f(5, 36);
  for(i = PI; i <= (1.5*PI); i += gap)
  {
    glVertex2d(radius* cos(i) + (5+radius), radius * sin(i) + 36); //Top Left
  }
  glVertex2f(wi-5, 2);
  glVertex2f(wi-5, 36);
  glVertex2f(82, 36);
  radius = 10;
  for(i = (1.5*PI); i >= PI; i -= gap)
  {

    glVertex2d(radius* cos(i) + (92-radius), radius * sin(i) + (36+radius)); //Top Left
  }
  glVertex2f(72, 46);
  glVertex2f(72, 500);
  glVertex2f(5, 500);
  glEnd();
  glDisable(GL_BLEND);

  glBegin(GL_LINE_LOOP);

  radius = 35;
  glColor4f(.3, .5, .68, .4);
  glVertex2f(5, 36);
  for(i = PI; i <= (1.5*PI); i += gap)
  {
    glVertex2d(radius* cos(i) + (5+radius), radius * sin(i) + 36); //Top Left
  }

  glVertex2f(wi-5, 2);
  glVertex2f(wi-5, 36);
  glVertex2f(82, 36);
  radius = 10;
  for(i = (1.5*PI); i >= PI; i -= gap)
  {

    glVertex2d(radius* cos(i) + (92-radius), radius * sin(i) + (36+radius)); //Top Left
  }
  glVertex2f(72, 46);
  glVertex2f(72, 500);
  glVertex2f(5, 500);

  glEnd();
  glPopAttrib();

}

//  ******************************************************************************************
// Function name:       void close_splash(char *a, float b)
// close slpalshscreen callback
//  ******************************************************************************************
void close_splash(char *a, float b){
  _switch("MHmain", 0);
}


//  ******************************************************************************************
// Function name:        int substitute_char(char* str, char fromchar, char tochar )
//  Take3 par:  1. String -  2. char to find  -  3. char to replace
//  traverse the string searching for par 2 and substitute it with par 3
//  This function is actualli used in cell_draw() function (see above) to strip "_" char from targets names.
//  ******************************************************************************************
int substitute_char(char* str, char fromchar, char tochar )
{
   int i;

   if (!str) return 0;                  //The string Exist
   for (i=0; i<=strlen(str); i++){      //traverse he string
       if (str[i] == fromchar){         //Have we found the char we ware looking for?
				str[i] = tochar;        // substitute it!
       }
	}
   return 1;                            //All right.
}



