/*
Copyright (c) 2001-2005 MakeHuman team www.makehuman.org
Author: Paolo Colombo

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef UI_H
#define UI_H

// Definitions
#define LIGHTBLUE	.37,0.56,0.71
#define BLACK	0.0,0.0,0.0
#define CELLHELP "This is a target - Click LMB and while holding drag left and right."
#define BS_HELP "This is a BodySetting - Click LMB to apply"

#ifdef HAVE_CONFIG_H
  #include <config.h>
#endif

// function prototypes
void SetUP_UI();
void Draw_UI(int w, int h);
void OnSlider(int x, int y);
void sliderUpdate(int oldpos, int pos);
void OnRelease(void);
void OnClick(int x, int y);
void OnOver(int x, int y);
void _switch(char *, float);
void Draw_Decoration(int wi, int hi);
void Draw_Decoration2(int wi, int hi);
void Draw_Axis();
void Draw_Grid();
int substitute_char(char *, char, char);
void _buildSliders(char *a, float b);
void reset_mesh(char *a , float b);
void _splashScreen(char *a , float b);
void close_splash(char *, float);
void PrintText(int x, int y, char *text, char *color);
void PrintLabel(int x, int y, char *text, char *color);
void setfont(char* name, int size);
void drawstr(GLuint x, GLuint y, char* format, ...);
GLuint load_texture(char *file);
void _select(char *a, float b, void(*operaz)(char *, float));
void _freeSliders(void);
void _buildSliders(char *, float);
void resetAll(char *, float);
void DrawCircle();
void DrawSquareFill(float, float, float, float, float, float, float, float);
void DrawRoundedSquareFill(float, float , float , float , float , float, float , float );
void Draw_Cells(int w, int h);
int check(char *a);

void _splashScreen(char *, float);
void _exitYN(char *, float);

void _manageFullscreen(char *, float);
void _SS_anim(char *, float);
void _manageAxis(char *, float );
void _manageGrid(char *, float );
void _render(char *, float);

void setOrthographicProjection(int wi, int hi);
void resetPerspectiveProjection();
void togglewire();


#endif // UI_H

